
// TurtleVisualDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TurtleVisual.h"
#include "TurtleVisualDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif
#define	_DEBUGX

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CTurtleVisualDlg dialog



CTurtleVisualDlg::CTurtleVisualDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_TURTLEVISUAL_DIALOG, pParent)
	, m_nDisks(5)
	, m_dwFreqms(1000)
	, m_nMoves(1)
	, m_nTotMoves(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	::memset(&(m_arDisks[0]), '\0', sizeof(m_arDisks));
	m_bDrawWindows = FALSE;
}

CTurtleVisualDlg::~CTurtleVisualDlg()
{
	FreeDisks();
}

void CTurtleVisualDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ST_OVERLAY, m_stWork);
	DDX_Text(pDX, IDC_EDIT_DISKS, m_nDisks);
	DDX_Text(pDX, IDC_EDIT_FREQ, m_dwFreqms);
	DDV_MinMaxUInt(pDX, m_dwFreqms, 0, 1000);
	DDX_Text(pDX, IDC_EDIT_COUNT, m_nMoves);
	DDX_Text(pDX, IDC_EDIT_NMOVES, m_nTotMoves);
}

BEGIN_MESSAGE_MAP(CTurtleVisualDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_DOIT, &CTurtleVisualDlg::OnBnClickedButtonDoit)
	ON_BN_CLICKED(IDC_BUTTON_SHOW, &CTurtleVisualDlg::OnBnClickedButtonShow)
	ON_BN_CLICKED(IDC_BUT_MOVE, &CTurtleVisualDlg::OnBnClickedButMove)
	ON_MESSAGE(WM_DOMOVE, &CTurtleVisualDlg::ShowNextMove)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CTurtleVisualDlg message handlers

BOOL CTurtleVisualDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_bmWindow = ::LoadBitmap(::AfxGetInstanceHandle(), (LPCTSTR)IDB_BM_WINDOW);
	m_bmDoor = ::LoadBitmap(::AfxGetInstanceHandle(), (LPCTSTR)IDB_BM_DOOR);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTurtleVisualDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTurtleVisualDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTurtleVisualDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

#define	BASE_HT		20
#define	PEG_FLUFF	20
#define	MAX_DISK_HT	30
#define	PLOT_HEIGHT	6
#define	PEG_WID		8
#define	MIN_DISK_W	12
#define	DISK_FUDGE	8

#define	CR_OUTLINE	RGB(128, 128, 128)
#define	CR_BG		RGB(192, 192, 192)

void CTurtleVisualDlg::FreeDisks()
{
	int i;

	for (i = 0; i < 4; i++) {
		if (m_arDisks[i] != NULL) {
			delete[] m_arDisks[i];
			m_arDisks[i] = NULL;
		}
	}
}

void CTurtleVisualDlg::AllocDisks()
{
	int i, nd;

	nd = m_nDisks * 2;
	for (i = 0; i < 4; i++) {
		m_arDisks[i] = new int[nd];
		if (m_arDisks[i] != NULL) {
			::memset(m_arDisks[i], '\0', nd * sizeof(int));
		}
	}
	for (i = 0; i < m_nDisks; i++){
		*(m_arDisks[0] + i) = m_nDisks - i;
		*(m_arDisks[2] + i) = -(m_nDisks - i);
	}
}

void CTurtleVisualDlg::DrawDisk(CDC *pdc, int nDisk, int nPeg, int nPos)
{
	CBrush br(nDisk < 0 ? RGB(0, 0, 0) : RGB(255, 255, 255)), *psb;
	CPen pn(PS_SOLID, 1, CR_OUTLINE), *psp;
	int nSize, nWin, nWid;
	int x1, x2, y1, y2, i, y;
	CBitmap bmh;
	BITMAP bminfo;
	DWORD dwRopf, dwRopb;
	BOOL bDrawPlotOnly;

	if (nDisk == 0) {
		nDisk = m_nDisks;
		bDrawPlotOnly = TRUE;
	} else {
		bDrawPlotOnly = FALSE;
	}
	if (nDisk < 0) {
		nDisk = -nDisk;
		dwRopb = WHITENESS;
		dwRopf = BLACKNESS;
	} else {
		dwRopb = BLACKNESS;
		dwRopf = WHITENESS;
	}
	nSize = (m_nDisks - nDisk);
	x1 = m_pegs[nPeg].x - m_nDiskWidth_2[nSize];
	y1 = m_pegs[nPeg].y - m_nDiskHeight*nPos;
	x2 = m_pegs[nPeg].x + m_nDiskWidth_2[nSize];
	y2 = m_pegs[nPeg].y - m_nDiskHeight * (nPos + 1);
	if (bDrawPlotOnly == FALSE) {
		psb = pdc->SelectObject(&(br));
		psp = pdc->SelectObject(&(pn));
		pdc->RoundRect(x1, y1,
			x2, y2,
			3, 3);
		pdc->SelectObject(psp);
		pdc->SelectObject(psb);
	}

	if (m_bDrawWindows == TRUE) {
		BYTE brt = 192 - nPeg * 32;
		/* Bottom row */
		if (nPos == 0) {
			pdc->FillSolidRect(x1, y1 + 1, x2 - x1, PLOT_HEIGHT, RGB(brt, brt, brt));
		}
		if (bDrawPlotOnly == FALSE) {
			nWin = (nDisk - 1);
			nWid = m_nDiskWidth_2[nSize] * 2;
			if (nSize == 0) {
				bmh.Attach(m_bmDoor);
			} else {
				bmh.Attach(m_bmWindow);
			}
			bmh.GetBitmap(&(bminfo));
			/* Draw center */
			x1 = m_pegs[nPeg].x - bminfo.bmWidth / 2;
			if (nSize == 0) {
				y = y1 - bminfo.bmHeight;
			} else {
				y = y2 + bminfo.bmHeight / 2;
			}
			y1 = y2 + bminfo.bmHeight / 2;

			pdc->MaskBlt(x1, y,
				bminfo.bmWidth, bminfo.bmHeight,
				pdc, 0, 0, bmh, 0, 0, MAKEROP4(dwRopf, dwRopb));
			if (nSize == 0) {
				bmh.Detach();
				bmh.Attach(m_bmWindow);
			}
			for (i = 1; i <= nWin; i++) {
				pdc->MaskBlt(x1 - i*m_nInc / 2, y1,
					bminfo.bmWidth, bminfo.bmHeight,
					pdc, 0, 0, bmh, 0, 0, MAKEROP4(dwRopf, dwRopb));
				pdc->MaskBlt(x1 + i*m_nInc / 2, y1,
					bminfo.bmWidth, bminfo.bmHeight,
					pdc, 0, 0, bmh, 0, 0, MAKEROP4(dwRopf, dwRopb));
			}
			bmh.Detach();
		}
	}
}

void CTurtleVisualDlg::DrawPegs()
{
	RECT r;
	int dist, ys, i, j;
	int *p;
	CDC *pdc;

	m_stWork.GetClientRect(&(r));
	pdc = m_stWork.GetDC();
	pdc->FillSolidRect(&(r), CR_BG);
	ys = r.bottom - BASE_HT;
	m_nDiskHeight = ((ys - r.top) - PEG_FLUFF) / m_nDisks;
	if (m_nDiskHeight > MAX_DISK_HT) {
		m_nDiskHeight = MAX_DISK_HT;
	}
	pdc->FillSolidRect(r.left, ys, r.right, r.bottom, RGB(64, 64, 64));

	dist = (r.right - r.left) / 4;
	for (i = 1, m_pegs[0].x = dist / 2, m_pegs[0].y = ys; i < 4; i++) {
		m_pegs[i].x = m_pegs[i - 1].x + dist;
		m_pegs[i].y = m_pegs[i - 1].y;
	}
#ifdef DRAW_PEGS
	for (i = 0; i < 4; i++) {
		pdc->FillSolidRect(m_pegs[i].x - PEG_WID / 2, r.top, PEG_WID, m_pegs[i].y, RGB(64, 64, 64));
	}
#endif
	dist -= DISK_FUDGE;
	m_nInc = (dist - MIN_DISK_W) / m_nDisks;
	for (i = 0; i < m_nDisks; i++) {
		m_nDiskWidth_2[i] = dist/2;
		dist -= m_nInc;
	}

	for (j = 0; j < 4; j++) {
		p = m_arDisks[j];
		if (p != NULL) {
			for (i = 0; i < m_nDisks * 2; i++) {
				if (i > 0 && p[i] == 0) {
					break;
				}
				DrawDisk(pdc, p[i], j, i);
			}
		}
	}
#ifdef FILL_DEBUG
	for (i = m_nDisks; i > 0; i--) {
		for (j = 0; j < 4; j++) {
			DrawDisk(pdc, (j & 1) ? -i : i, j, m_nDisks-i);
		}
	}
#endif
	m_stWork.ReleaseDC(pdc);
}

void CTurtleVisualDlg::OnBnClickedButtonDoit()
{
	UpdateData(TRUE);
	if (m_nDisks > MAX_DISKS) {
		m_nDisks = MAX_DISKS;
		UpdateData(FALSE);
	} else if (m_nDisks < 1) {
		m_nDisks = 1;
		UpdateData(FALSE);
	}
	FreeDisks();
	AllocDisks();
	DrawPegs();
	m_arAns.RemoveAll();
	m_nTotMoves = 0;
	solve(m_nDisks);
}


void CTurtleVisualDlg::OnBnClickedButtonShow()
{
	UpdateData(TRUE);
	if (m_nDisks > MAX_DISKS) {
		m_nDisks = MAX_DISKS;
		UpdateData(FALSE);
	} else if (m_nDisks < 1) {
		m_nDisks = 1;
		UpdateData(FALSE);
	}
	FreeDisks();
	AllocDisks();
	m_bDrawWindows = TRUE;
	DrawPegs();
	m_bDrawWindows = FALSE;
}

void CTurtleVisualDlg::OnBnClickedButMove()
{
	UpdateData(TRUE);
	if (m_nMoves == 1) {
		ShowNextMove(0, 0);
	} else {
		SetTimer(TID_DOMOVE, m_dwFreqms, NULL);
	}
}

LRESULT CTurtleVisualDlg::ShowNextMove(WPARAM wParam, LPARAM lParam)
{
	int *pf, *pt;
	int i, nd, j, f, t;
	SMove *pm;

	if (m_arAns.IsEmpty() == FALSE) {
		pm = (SMove *)m_arAns.GetAt(0);
		m_arAns.RemoveAt(0);
		f = pm->m_from;
		t = pm->m_to;
		pf = m_arDisks[f];
		pt = m_arDisks[t];
		nd = m_nDisks * 2;
		for (i = 0; i < nd && pf[i] != 0; i++) {
			;
		}
		if (i > 0 && i < nd) {
			i--;
			for (j = 0; j < nd && pt[j] != 0; j++) {
				;
			}
			pt[j] = pf[i];
			pf[i] = 0;
		}
		DrawPegs();
		m_nTotMoves++;
		UpdateData(FALSE);
		delete pm;
	}
	return(0);
}

void CTurtleVisualDlg::move(int d, int s, int f, int t)
{
	SMove *pm = new SMove;

	f &= 3;
	t &= 3;
#ifdef _DEBUGX
	CString szMsg;

	szMsg.Format(_T("Move %s disk %d from %d to %d\n"), s == 0 ? _T("White") : _T("Black"), d, f+1, t+1);
	::OutputDebugString(szMsg);
#endif
	pm->m_color = s;
	pm->m_disk = d;
	pm->m_from = f;
	pm->m_to = t;
	m_arAns.Add(pm);
}

void CTurtleVisualDlg::hanoi(int b, int t, int s, int f, int u, int d)
{
	if (t <= b) {
		hanoi(b - 1, t, s, f, d, u);
		move(b, s, f, d);
		hanoi(b - 1, t, s, u, f, d);
	}
}

void CTurtleVisualDlg::solve(int n)
{
	int s, i, s2;

	s = 0;
	move(1, 0, 0, 1);
	for (i = 1; i < n; i++) {
		s = 1 - s;
		s2 = s + s;
		move(i, s, s2, s2 + 2);
		hanoi(i - 1, 1, s, s2 + 1, s2, s2 + 2);
		move(i + 1, s, s2, s2 + 1);
		hanoi(i, 1, s, s2 + 2, s2, s2 + 1);
	}
	s = 1 - s;
	s2 = s + s;
	move(n, s, s2, s2 + 2);
	for (i = n - 1; i >= 1; i--) {
		s = 1 - s;
		s2 = s + s;
		hanoi(i, 1, s, s2 + 1, s2 + 2, s2);
		move(i + 1, s, s2 + 1, s2 + 2);
		hanoi(i - 1, 1, s, s2, s2 + 2, s2 + 1);
		move(i, s, s2, s2 + 2);
	}
	s = 1 - s;
	move(1, 0, 1, 2);
}



void CTurtleVisualDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == TID_DOMOVE) {
		if (m_nMoves > 0) {
			if (m_nMoves-- == 1) {
				KillTimer(TID_DOMOVE);
			}
			UpdateData(FALSE);
			PostMessage(WM_DOMOVE);
		}
		return;
	}
	CDialogEx::OnTimer(nIDEvent);
}
