
// TurtleVisualDlg.h : header file
//

#pragma once
#include "afxwin.h"
#define	MAX_DISKS	100

#define	WM_DOMOVE		(WM_USER+1000)

struct SMove {
	int m_from;
	int m_to;
	int m_color;
	int m_disk;
};
// CTurtleVisualDlg dialog
class CTurtleVisualDlg : public CDialogEx
{
// Construction
public:
	CTurtleVisualDlg(CWnd* pParent = NULL);	// standard constructor
	~CTurtleVisualDlg();
// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_TURTLEVISUAL_DIALOG };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
private:
	void DrawPegs(void);
	void DrawDisk(CDC *pdc, int nSize, int nPeg, int nPos);
	void FreeDisks(void);
	void AllocDisks(void);
	void solve(int n);
	void hanoi(int b, int t, int s, int f, int u, int d);
	void move(int d, int s, int f, int t);
	afx_msg LRESULT ShowNextMove(WPARAM wParam, LPARAM lParam);
private:
	int m_nDiskHeight;
	POINT m_pegs[4];
	int *m_arDisks[4];
	int m_nDiskWidth_2[MAX_DISKS];
	BOOL m_bDrawWindows;
	HBITMAP m_bmWindow;
	HBITMAP m_bmDoor;
	int m_nInc;
	CPtrArray m_arAns;
	int m_nCurMove;
public:
	CStatic m_stWork;
	int m_nDisks;
	afx_msg void OnBnClickedButtonDoit();
	DWORD m_dwFreqms;
	afx_msg void OnBnClickedButtonShow();
	int m_nMoves;
	afx_msg void OnBnClickedButMove();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	int m_nTotMoves;
};
